#include <iostream>
#include <vector>
#include <string>
#include <functional>
using namespace std;
int h, w;
vector<string> maze;
void advance(char dir, int& x, int& y)
{
	switch (dir)
	{
	case 'U':
		x--;
		break;
	case 'D':
		x++;
		break;
	case 'L':
		y--;
		break;
	case 'R':
		y++;
		break;
	}
}
char peek(char dir, int x, int y)
{
	switch (dir)
	{
	case 'U':
		if(x > 0) return maze[x - 1][y];
		break;
	case 'D': 
		if(x < h - 1) return maze[x + 1][y];
		break;
	case 'L': 
		if(y > 0) return maze[x][y - 1];
		break;
	case 'R': 
		if(y < w - 1) return maze[x][y + 1];
		break;
	}
	return '\0';
}
bool canMove(char dir, int x, int y)
{
	switch (dir)
	{
	case 'U': return x > 0 && (maze[x - 1][y] == '.' || maze[x - 1][y] == 'S');
	case 'D': return x < h - 1 && (maze[x + 1][y] == '.' || maze[x + 1][y] == 'S');
	case 'L': return y > 0 && (maze[x][y - 1] == '.' || maze[x][y - 1] == 'S');
	case 'R': return y < w - 1 && (maze[x][y + 1] == '.' || maze[x][y + 1] == 'S');
	}
	return false;
}
int main()
{
	int d;
	cin >> h >> w >> d;
	maze.resize(h);
	int sX = -1;
	int sY = -1;
	for (int i = 0; i < h; i++)
	{
		cin >> maze[i];
		if (sX < 0)
			for (int j = 0; j < w; j++)
				if (maze[i][j] == 'S')
				{
					sX = i;
					sY = j;
					break;
				}
	}
	int l;
	cin >> l;
	string path;
	cin >> path;
	vector<int> answ(l, 0);
	int posX = sX;
	int posY = sY;
	int keys = 0;
	for (int i = 0; i<l; i++)
	{
		char dir = path[i];
		char nxt = peek(dir, posX, posY);
		while (nxt != '#' && nxt != '\0')
		{
			if (nxt == '.' || nxt == 'S')
			{
				advance(dir, posX, posY);
				answ[i]++;
			}
			else if (nxt == 'K')
			{
				keys++;
				advance(dir, posX, posY);
				maze[posX][posY] = '.';
				answ[i]++;
			}
			else if (nxt == 'L' && keys > 0)
			{
				keys--;
				advance(dir, posX, posY);
				maze[posX][posY] = '.';
				answ[i]++;
			}
			else
				break;
			nxt = peek(dir, posX, posY);
		}
	}
	for (auto i : answ)
		cout << i << endl;
}