#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
const ll INF = (ll)1e18;
const double PI = acos(-1.0);

const int MAX_N = 615000;
int to[MAX_N];
vector<int> gr[MAX_N];
int p[MAX_N];

int tovert(string s)
{
    reverse(s.begin(), s.end());
    while (s.size() < 4)
        s += 'A' - 1;
    reverse(s.begin(), s.end());
    return (s[0] - 'A' + 1) * 28 * 28 * 28 + (s[1] - 'A' + 1) * 28 * 28 + (s[2] - 'A' + 1) * 28 + (s[3] - 'A' + 1);
}

string toword(int a)
{
    string s = "";
    while (a > 0)
    {
        s += 'A' - 1 + (a % 28);
        a /= 28;
    }
    reverse(s.begin(), s.end());
    return s;
}

int get_p(int v)
{
    if (v < 0 || p[v] == v)
        return v;
    else
        return p[v] = get_p(p[v]);
}

void unite(int a, int b)
{
    p[a] = get_p(b);
}

void do_bad(int v)
{
    if (p[v] == -2)
        return;
    p[v] = -2;
    for (int nxt : gr[v])
    {
        do_bad(nxt);
    }
}

void do_cycle(int v)
{
    int vv;
    while (p[v] != -3)
    {
        vv = p[v];
        p[v] = -3;
        v = vv;
    }
}

int main()
{
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    for (int i = 0; i < MAX_N; i++)
    {
        to[i] = -1;
        p[i] = i;
    }

    int n;
    cin >> n;
    string sa, sb, sc;
    int a, b;
    for (int i = 0; i < n; i++)
    {
        cin >> sa >> sb >> sc;
        a = tovert(sa);
        b = tovert(sc);
        
        if (to[a] != -1)
        {
            if (to[a] != b)
            {
                do_bad(a);
            }
        }
        else if (get_p(b) == a)
        {
            to[a] = b;
            gr[b].push_back(a);
            if (a != b)
                do_cycle(a);
        }
        else
        {
            to[a] = b;
            gr[b].push_back(a);
            unite(a, b);
        }
    }

    int q;
    cin >> q;
    char c;
    while (q--)
    {
        cin >> c;
        if (c == '?')
        {
            cin >> sa;
            a = tovert(sa);
            a = get_p(a);
            if (a == -2)
            {
                cout << "TOO COMPLEX" << endl;
            }
            else if (a == -3)
            {
                cout << "INFINITE LOOP" << endl;
            }
            else
            {
                cout << toword(a) << endl;
            }
        }
        else
        {
            cin >> sa >> sb >> sc;
            a = tovert(sa);
            b = tovert(sc);

            if (to[a] != -1)
            {
                if (to[a] != b)
                {
                    do_bad(a);
                }
            }
            else if (get_p(b) == a)
            {
                to[a] = b;
                gr[b].push_back(a);
                if (a != b)
                    do_cycle(a);
            }
            else
            {
                to[a] = b;
                gr[b].push_back(a);
                unite(a, b);
            }
        }
    }

    return 0;
}