#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
const ll INF = (ll)1e18;
const double PI = acos(-1.0);

const int MAX_N = 100005;
int n;
ll A[MAX_N];
ll nok[MAX_N];

ll gcd(ll a, ll b)
{
    if (b == 0)
        return a;
    else
        return gcd(b, a % b);
}

ll get_nok(ll a, ll b)
{
    return a * b / gcd(a, b);
}

int main()
{
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    for (int i = 0; i < n; i++)
    {
        cin >> A[i];
        A[i]++;
        if (i == 0)
            nok[i] = A[i];
        else
            nok[i] = get_nok(nok[i - 1], A[i]);
    }

    int q;
    cin >> q;
    ll b;
    while (q--)
    {
        cin >> b;
        b--;
        ll left = -1, right = n, mid;
        while (left + 1 < right)
        {
            mid = (left + right) / 2;
            if (b % nok[mid] == 0)
            {
                left = mid;
            }
            else
            {
                right = mid;
            }
        }

        if (right == n)
            cout << -1 << endl;
        else
            cout << right + 1 << endl;
    }

    return 0;
}