#include <iostream>
#include <vector>
#include <set>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> m >> n;
        vector<vector<int>> d(m, vector<int>(m, 0));
        vector<vector<bool>> used(m, vector<bool>(m, false));
        for (int i = 0; i < n; ++i) {
            int x, y;
            cin >> x >> y;
            --x;
            --y;
            used[x][y] = true;
            for (int j = 0; j < m; ++j) {
                d[x][j]++;
                d[j][y]++;
            }
            int xcop = x, ycop = y;
            while (xcop >= 0 && ycop >= 0) {
                d[xcop--][ycop--]++;
            }
            xcop = x;
            ycop = y;
            while (xcop >= 0 && ycop < m) {
                d[xcop--][ycop++]++;
            }
            xcop = x;
            ycop = y;
            while (xcop < m && ycop < m) {
                d[xcop++][ycop++]++;
            }
            xcop = x;
            ycop = y;
            while (xcop < m && ycop >= 0) {
                d[xcop++][ycop--]++;
            }
        }
        int ans = 0;
        for (int i = 0; i < m; ++i) {
            for (int j = 0; j < m; ++j) {
                if (d[i][j] != n) {
                    continue;
                }
                bool can = true;
                for (int q = i - 1; q <= i + 1; ++q) {
                    if (q < 0 || q >= m) {
                        continue;
                    }
                    for (int w = j - 1; w <= j + 1; ++w) {
                        if (w < 0 || w >= m) {
                            continue;
                        }
                        if (used[q][w]) {
                            can = false;
                            break;
                        }
                    }
                    if (!can) {
                        break;
                    }
                }
                if (can) {
                    ++ans;
                }
            }
        }
        cout << ans << "\n";
    }

    return 0;
}
