#include <iostream>
#include <vector>
#include <set>
#include <map>

using namespace std;

const int MAXN = 150;

vector<vector<long long>> g, maxbval;
vector<long long> a, b, ans;

void dfs(int v) {
    for (int i = 1; i <= a[v]; ++i) {
        maxbval[v][i] = b[v];
    }
    for (int u : g[v]) {
        dfs(u);
        for (int i = 1; i < MAXN; ++i) {
            maxbval[v][i] = max(maxbval[v][i], maxbval[u][i]);
        }
    }
    for (int i = 1; i < MAXN; ++i) {
        ans[v] += maxbval[v][i];
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    g.resize(n);
    a.resize(n);
    b.resize(n);
    ans.resize(n, 0);
    maxbval.resize(n, vector<long long>(MAXN, 0));
    for (int i = 0; i < n; ++i) {
        int p;
        cin >> p >> a[i] >> b[i];
        if (p != 0) {
            g[p - 1].emplace_back(i);
        }
    }
    dfs(0);
    for (int i = 0; i < n; ++i) {
        cout << ans[i] << "\n";
    }

    return 0;
}
