#include <iostream>
#include <vector>
#include <set>
#include <map>

using namespace std;

const long long MAXB = 1e8;

long long gcd(long long a, long long b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

long long nok(long long a, long long b) {
    return a * b / gcd(a, b);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<long long> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        ++a[i];
    }
    vector<long long> prefa(n);
    prefa[0] = a[0];
    for (int i = 1; i < n; ++i) {
        if (prefa[i - 1] > MAXB) {
            prefa[i] = prefa[i - 1];
        }
        else {
            prefa[i] = nok(a[i], prefa[i - 1]);
        }
    }
    int q;
    cin >> q;
    while (q--) {
        long long b;
        cin >> b;
        --b;
        int left = -1, right = n;
        while (right - left > 1) {
            int mid = (left + right) / 2;
            if (b % prefa[mid] == 0) {
                left = mid;
            }
            else {
                right = mid;
            }
        }
        if (right < n) {
            cout << right + 1 << "\n";
        }
        else {
            cout << "-1\n";
        }
    }

    return 0;
}
