#define _GLIBCXX_DEBUG
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> ii;
typedef vector<int> vi;

const int INF = 1e9;

//#define int ll

vector<pair<int, int>> arr;
vector<vector<int>> graph;
vector<vector<int>> ans;

void dfs(int v)
{
    //cout << '?' << v << ' ' << arr[v].first << ' ' << arr[v].second << '\n';
    for (int i = 0; i <= arr[v].first; i++)
    {
        ans[v][i] = max(ans[v][i], arr[v].second);
    }
    for (auto to : graph[v])
    {
        dfs(to);
        for (int i = 0; i < 100; i++)
        {
            ans[v][i] = max(ans[v][i], ans[to][i]);
        }
    }
}

struct Event
{
    int x, y1, y2, typ;
};

bool operator<(Event a, Event b)
{
    if (a.x != b.x)
        return a.x < b.x;
    return a.typ < b.typ;
}

vector<pair<int, int>> t;
vector<int> c;

void build(int v, int l, int r)
{
    if (l + 1 == r)
    {
        t[v] = {0, 1};
        return;
    }
    int mid = (l + r) / 2;
    build(2 * v + 1, l, mid);
    build(2 * v + 2, mid, r);
    t[v] = {0, t[2 * v + 1].second + t[2 * v + 2].second};
}

void push(int v)
{
    c[2 * v + 1] += c[v];
    c[2 * v + 2] += c[v];
    c[v] = 0;
}

void update(int v, int l, int r, int mid)
{
    t[v].first = min(t[2 * v + 1].first + c[2 * v + 1], t[2 * v + 2].first + c[2 * v + 2]);
    if (t[2 * v + 1].first + c[2 * v + 1] == t[2 * v + 2].first + c[2 * v + 2])
    {
        t[v].second = t[2 * v + 1].second + t[2 * v + 2].second;
    }
    if (t[2 * v + 1].first + c[2 * v + 1] < t[2 * v + 2].first + c[2 * v + 2])
    {
        t[v].second = t[2 * v + 1].second;
    }
    if (t[2 * v + 1].first + c[2 * v + 1] > t[2 * v + 2].first + c[2 * v + 2])
    {
        t[v].second = t[2 * v + 2].second;
    }
}

void modify(int v, int l, int r, int a, int b, int x)
{
    if (b <= l || r <= a)
    {
        return;
    }
    if (a <= l && r <= b)
    {
        c[v] += x;
        return;
    }
    int mid = (l + r) / 2;
    push(v);
    modify(2 * v + 1, l, mid, a, b, x);
    modify(2 * v + 2, mid, r, a, b, x);
    update(v, l, r, mid);
}

int gett(int v, int l, int r, int a, int b)
{
    if (a <= l && r <= b)
    {
        if (t[v].first + c[v] == 0) {
            return r - l - t[v].second;
        }
        else {
            return 0;
        }

    }
}

vector<int> tin, tout;
int timer = 0;

void dfs1(int v)
{
    tin[v] = timer++;
    for (auto to : graph[v])
    {
        dfs1(to);
    }
    tout[v] = timer++;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    graph.resize(n);
    arr.resize(n);
    for (int i = 0; i < n; i++)
    {
        int p;
        cin >> p >> arr[i].first >> arr[i].second;
        arr[i].first--;
        p--;
        if (p != -1)
        {
            graph[p].push_back(i);
        }
    }
    if (n <= 500)
    {
        tin.resize(n), tout.resize(n);
        dfs1(0);
        t.resize(4 * 1e6 + 228);
        c.resize(4 * 1e6 + 228);
        build(0, 0, 1e6 + 1);
        for (int i = 0; i < n; i++)
        {
            vector<Event> events;
            for (int j = 0; j < n; j++)
            {
                if (tin[i] <= tin[j] && tin[j] <= tout[i])
                {
                    events.push_back({0, 1, arr[j].second, 0});
                    events.push_back({arr[j].first, 1, arr[j].second, 1});
                }
            }
            sort(events.begin(), events.end());
            int prev_ind = -1;
            ll res = 0;
            for (auto e : events)
            {
                int x = e.x, y1 = e.y1, y2 = e.y2;
                if (e.typ == 0)
                {
                    modify(0, 0, 1e6 + 1, y1, y2 + 1, 1);
                }
                else
                {
                    //cout << '!' << x << ' ' << prev_ind << ' ' << gett(0, 0, 1e6 + 1, 0, 1e6 + 1) << '\n';
                    res += (ll)(x - prev_ind) * gett(0, 0, 1e6 + 1, 0, 1e6 + 1);
                    modify(0, 0, 1e6 + 1, y1, y2 + 1, -1);
                    prev_ind = x;
                }
            }
            cout << res << '\n';
        }
        return 0;
    }
    ans.resize(n, vector<int>(100));
    dfs(0);
    for (int i = 0; i < n; i++)
    {
        int cnt = 0;
        for (int j = 0; j < 100; j++)
        {
            cnt += ans[i][j];
        }
        cout << cnt << '\n';
    }
}