#include <iostream>
#include <set>
#include <algorithm>
#include <vector>

using namespace std;

int h, w, d;
vector<set<pair<int, int>>> col;
vector<set<pair<int, int>>> row;
const pair<int, int> non = {-1, -1};

pair<int, int> getnxt(set<pair<int, int>>& qu, pair<int, int> el) {
    auto it = qu.upper_bound(el);
    if (it == qu.end() || (*it) < el) return non;
    return (*it);
}

pair<int, int> getprv(set<pair<int, int>>& qu, pair<int, int> el) {
    auto it = qu.lower_bound(el);
    if (it == qu.begin()) return non;
    return (*(--it));
}

signed main() {
    cin >> h >> w >> d;
    row.resize(h);
    col.resize(w);
    char cc;
    int crx, cry;
    int keys = 0;
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            cin >> cc;
            if (cc == '#') {
                row[i].insert({j, cc});
                col[j].insert({i, cc});
            } else if (cc == 'K') {
                row[i].insert({j, cc});
                col[j].insert({i, cc});
            } else if (cc == 'L') {
                row[i].insert({j, cc});
                col[j].insert({i, cc});
            } else if (cc == 'S') {
                crx = i;
                cry = j;
            }
        }
    }

    int l;
    cin >> l;
    while (l--) {
        int nx = crx;
        int ny = cry;
        char c;
        cin >> c;
        if (c == 'R') {
            while (1) {
                auto el = getnxt(row[nx], {ny, 1111});
                char crc = el.second;
                if (el == non) {
                    ny = w - 1;
                    break;
                }
                if (crc == '#' || (crc == 'L' && keys == 0)) {
                    ny = el.first - 1;
                    break;
                }
                if (crc == 'K') {
                    keys++;
                    row[nx].erase(el);
                    col[el.first].erase({nx, crc});
                    ny = el.first;
                    continue;
                }
                if (crc == 'L') {
                    keys--;
                    row[nx].erase(el);
                    col[el.first].erase({nx, crc});
                    ny = el.first;
                    continue;
                }
            }
        } else if (c == 'L') {
            while (1) {
                auto el = getprv(row[nx], {ny, -1111});
                char crc = el.second;
                if (el == non) {
                    ny = 0;
                    break;
                }
                if (crc == '#' || (crc == 'L' && keys == 0)) {
                    ny = el.first + 1;
                    break;
                }
                if (crc == 'K') {
                    keys++;
                    row[nx].erase(el);
                    col[el.first].erase({nx, crc});
                    ny = el.first;
                    continue;
                }
                if (crc == 'L') {
                    keys--;
                    row[nx].erase(el);
                    col[el.first].erase({nx, crc});
                    ny = el.first;
                    continue;
                }
            }
        } else if (c == 'D') {
            while (1) {
                auto el = getnxt(col[ny], {nx, 1111});
                char crc = el.second;
                if (el == non) {
                    nx = h - 1;
                    break;
                }
                if (crc == '#' || (crc == 'L' && keys == 0)) {
                    nx = el.first - 1;
                    break;
                }
                if (crc == 'K') {
                    keys++;
                    col[ny].erase(el);
                    row[el.first].erase({ny, crc});
                    nx = el.first;
                    continue;
                }
                if (crc == 'L') {
                    keys--;
                    col[ny].erase(el);
                    row[el.first].erase({ny, crc});
                    nx = el.first;
                    continue;
                }
            }
        } else if (c == 'U') {
            while (1) {
                auto el = getprv(col[ny], {nx, -1111});
                char crc = el.second;
                if (el == non) {
                    nx = 0;
                    break;
                }
                if (crc == '#' || (crc == 'L' && keys == 0)) {
                    nx = el.first + 1;
                    break;
                }
                if (crc == 'K') {
                    keys++;
                    col[ny].erase(el);
                    row[el.first].erase({ny, crc});
                    nx = el.first;
                    continue;
                }
                if (crc == 'L') {
                    keys--;
                    col[ny].erase(el);
                    row[el.first].erase({ny, crc});
                    nx = el.first;
                    continue;
                }
            }
        }
        cout << abs(crx - nx) + abs(cry - ny) << '\n';
        crx = nx;
        cry = ny;
    }
    return 0;
}
