#include <iostream>
#include <math.h>
#include <string>
#include <vector>
using namespace std;

#define int long long
#define all(x) x.begin(), x.end()

const int maxn = 1e6 + 13;
const int INF = 2e18 + 13;

int frL(int cx, int cy, vector<vector<int>> &left, vector<vector<char>> &a){
	if(a[cx][left[cx][cy]] != '.')return left[cx][cy] + 1;
	return left[cx][cy] = frL(cx, left[cx][cy], left, a);
}
int frR(int cx, int cy, vector<vector<int>> &right, vector<vector<char>> &a){
	if(a[cx][right[cx][cy]] != '.')return right[cx][cy] - 1;
	return right[cx][cy] = frR(cx, right[cx][cy], right, a);
}
int frU(int cx, int cy, vector<vector<int>> &up, vector<vector<char>> &a){
	if(a[up[cx][cy]][cy] != '.')return up[cx][cy] + 1;
	return up[cx][cy] = frU(up[cx][cy], cy, up, a);
}
int frD(int cx, int cy, vector<vector<int>> &down, vector<vector<char>> &a){
	if(a[down[cx][cy]][cy] != '.')return down[cx][cy] - 1;
	return down[cx][cy] = frD(down[cx][cy], cy, down, a);
}
signed main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	int h, w, d, n;
	string s;
	cin >> h >> w >> d;
	vector<vector<char>> a(h + 10, vector<char>(w + 10, '#'));
	int cx, cy;
	for(int i = 1; i <= h; ++i){
		for(int j = 1; j <= w; ++j){
			cin >> a[i][j];
			if(a[i][j] == 'S')cx = i, cy = j;
		}
	}
	a[cx][cy] = '.';
	cin >> n >> s;
	vector<vector<int>> left(h + 10, vector<int>(w + 10)),
					    right(h + 10, vector<int>(w + 10)),
					    up(h + 10, vector<int>(w + 10)),
					    down(h + 10, vector<int>(w + 10));
	for(int i = 1; i <= h; ++i){
		for(int j = 1; j <= w; ++j){
			up[i][j] = i - 1;
		}
	}		   

	for(int i = 1; i <= h; ++i){
		for(int j = 1; j <= w; ++j){
			down[i][j] = i + 1;
		}
	}		   

	for(int i = 1; i <= h; ++i){
		for(int j = 1; j <= w; ++j){
			left[i][j] = j - 1;
		}
	}		   

	for(int i = 1; i <= h; ++i){
		for(int j = 1; j <= w; ++j){
			right[i][j] = j + 1;
		}
	}		   

	if(d == 0){
		for(int i = 1; i <= h; ++i){
			for(int j = 1; j <= w; ++j){
				if(a[i][j] == '.')continue;
				if(a[i][j] == '#')continue;
				a[i][j] = '.';
			}
		}	
		for(int i = 0; i < n; ++i){
			if(s[i] == 'U'){
				int d = frU(cx, cy, up, a);
				cout << cx - d << "\n";
				cx = d;
			}else if(s[i] == 'D'){
				int d = frD(cx, cy, down, a);
				cout << d - cx << "\n";
				cx = d;
			}else if(s[i] == 'L'){
				int d = frL(cx, cy, left, a);
				cout << cy - d << "\n";
				cy = d;
			}else {
				int d = frR(cx, cy, right, a);
				cout << d - cy << "\n";
				cy = d;
			}
		}
	}else{
		int cntk = 0;
		for(int i = 0; i < n; ++i){
			if(s[i] == 'U'){
				int X = cx;
				while(a[cx - 1][cy] != '#'){
					cx = frU(cx, cy, up, a);
					if(a[cx - 1][cy] == '#')break;
					else if(a[cx - 1][cy] == 'K'){
						a[cx - 1][cy] = '.';
						cntk++;
					}else{
						if(cntk == 0)break;
						cntk--;
						a[cx - 1][cy] = '.';
					}
				}
				cout << X - cx << "\n";
				
			}else if(s[i] == 'D'){
				int X = cx;
				while(a[cx + 1][cy] != '#'){
					cx = frD(cx, cy, down, a);
					if(a[cx + 1][cy] == '#')break;
					else if(a[cx + 1][cy] == 'K'){
						a[cx + 1][cy] = '.';
						cntk++;
					}else{
						if(cntk == 0)break;
						cntk--;
						a[cx + 1][cy] = '.';
					}
				}
				cout << cx - X << "\n";
			}else if(s[i] == 'L'){
				int Y = cy;
				while(a[cx][cy - 1] != '#'){
					cy = frL(cx, cy, left, a);
					if(a[cx][cy - 1] == '#')break;
					if(a[cx][cy - 1] == 'K'){
						a[cx][cy - 1] = '.';
						cntk++;
					}else{
						if(cntk == 0)break;
						cntk--;
						a[cx][cy - 1] = '.';
					}
				}
				cout << Y - cy << "\n";
			}else {
				int Y = cy;
				while(a[cx][cy + 1] != '#'){
					cy = frR(cx, cy, right, a);
					if(a[cx][cy + 1] == '#')break;
					if(a[cx][cy + 1] == 'K'){
						a[cx][cy + 1] = '.';
						cntk++;
					}else{
						if(cntk == 0)break;
						cntk--;
						a[cx][cy + 1] = '.';
					}
				}
				cout << cy - Y << "\n";
			}
		}
	}

	return 0;
}