#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
//#include <intrin.h>

#include <bits/stdc++.h>
#include <chrono>
#include <random>
#include <ctime>

using namespace std;

typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
#define mp make_pair
#define pb push_back
#define rep(i, n) for (ll i = 0; i < (n); i++)
#define repb(i, n) for (ll i = n - 1; i>=0; --i)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
const ll inf = 1e9;
const ll MAXN = 1e6;
int m, n;

bool is_correct(int y, int x) {
    return y >= 0 && y < m && x >= 0 && x < m;
}


inline void SOLVE() {

    cin >> m >> n;
    vector<vector<bool>> used(m, vector<bool>(m));
    rep(i, n) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        used[y][x] = true;
    }
    // посчитать для каждой диагонали и вертикали и горизонтали количество ферзей
    // считаем горизонтали
    vector<vector<int>> dp(m, vector<int>(m));
    for (int i = 0; i < m; ++i) {
        int cnt = 0;
        for (int j = 0; j < m; ++j) {
            if (used[i][j])
                cnt++;
        }
        for (int j = 0; j < m; ++j) {
            dp[i][j] += cnt;
        }
    }
    // считаем вертикали
    for (int j = 0; j < m; ++j) {
        int cnt = 0;
        for (int i = 0; i < m; ++i) {
            if (used[i][j])
                cnt++;
        }
        for (int i = 0; i < m; ++i) {
            dp[i][j] += cnt;
        }
    }
    // считаем прямую диагональ
    for (int start = 0; start < m; ++start) {
        int dx = start;
        int dy = 0;
        int cnt = 0;
        while (dx >= 0 && dy < m) {
            if (used[dy++][dx--])
                cnt++;
        }
        dx = start;
        dy = 0;
        while (dx >= 0 && dy < m) {
            dp[dy++][dx--] += cnt;
        }
    }
    for (int start = 1; start < m; ++start) {
        int dy = start;
        int dx = m - 1;
        int cnt = 0;
        while (dx >= 0 && dy < m) {
            if (used[dy++][dx--])
                cnt++;
        }
        dy = start;
        dx = m - 1;
        while (dx >= 0 && dy < m) {
            dp[dy++][dx--] += cnt;
        }
    }
    // считаем обратную диагональ
    for (int start = 0; start < m; ++start) {
        int dx = start;
        int dy = 0;
        int cnt = 0;
        while (dx < m && dy < m) {
            if (used[dy++][dx++])
                cnt++;
        }
        dx = start;
        dy = 0;
        while (dx < m && dy < m) {
            dp[dy++][dx++] += cnt;
        }
    }
    for (int start = 1; start < m; ++start) {
        int dy = start;
        int dx = 0;
        int cnt = 0;
        while (dx < m && dy < m) {
            if (used[dy++][dx++])
                cnt++;
        }
        dy = start;
        dx = 0;
        while (dx < m && dy < m) {
            dp[dy++][dx++] += cnt;
        }
    }
    int ans = 0;
    for (int y = 0; y < m; ++y) {
        for (int x = 0; x < m; ++x) {
            bool f = true;
            for (int dy = -1; dy <= 1; ++dy) {
                for (int dx = -1; dx <= 1; ++dx) {
                    if (is_correct(y + dy, x + dx) && used[y + dy][x + dx])
                        f = false;
                }
            }
            if (f && dp[y][x] == n)
                ans++;
        }
    }
    cout << ans << '\n';
}

inline void IQ() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
}

signed main() {
#ifdef GOSHA
    freopen("../IO/input.txt", "r", stdin);
    freopen("../IO/output.txt", "w", stdout);
#endif
    IQ();
    ll T = 1;
    cin >> T;
    while (T--) {
        SOLVE();
    }
    return 0;
}