#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <sstream>
#include <cassert>
#include <vector>
#include <numeric>
#include <string>
#include <bitset>
#include <cmath>
#include <complex>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <ctime>

using namespace std;

#define en '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef unsigned int uint;
typedef long long ll;
typedef unsigned long long ull;
typedef __int128_t int128;
typedef double db;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef complex<long double> comp;

const int INF = 1e9 + 7;
const ll INFLL = 1e18;
const long double EPS = 1e-9;
const long double PI = 3.1415926535897932384626433832795;
//const long double PI = acos(-1);

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

bool IS_ONE_TEST = 1;
ld START_TIME, TIME;

void fast_in_out() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    map<int, vector<int>> id;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        ++a[i];
        id[a[i]].emplace_back(i);
    }
    int q;
    cin >> q;
    while (q--) {
        ll x;
        cin >> x;
        --x;
        if (x == 0) {
            cout << -1 << en;
            continue;
        }
        int mex = 0;
        vector<int> used(n, 0);
        for (ll i = 1; i * i <= x; ++i) {
            if (x % i == 0) {
                ll d1 = i, d2 = x / i;
                if (id.find(d1) != id.end()) {
                    for (auto &el: id[d1]) {
                        if (a[el] <= x) used[el] = 1;
                        while (mex < n && used[mex]) ++mex;
                    }
                }
                if (id.find(d2) != id.end()) {
                    for (auto &el: id[d2]) {
                        if (a[el] <= x) used[el] = 1;
                        while (mex < n && used[mex]) ++mex;
                    }
                }
            }
        }
        cout << (mex == n ? -1 : mex + 1) << en;
    }
}

int main() {
    START_TIME = clock();
    int TESTS = 1;
#ifdef __APPLE__
    TESTS = 1;
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    fast_in_out();
#endif
    if (!IS_ONE_TEST) cin >> TESTS;
    while (TESTS--) { solve(); }
#ifdef __APPLE__
    TIME = (clock() - START_TIME) / CLOCKS_PER_SEC;
    cerr << endl << TIME * 1000 << " ms." << endl;
#endif
    return 0;
}
