#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <math.h>
#include <cmath>
#include <complex>
#include <algorithm>

using namespace std;

#define rep(i, n) for (ll i = 0; i < n; i++)
#define reep(i, a, n) for (ll i = a; i < n; i++)
#define per(i, n) for (ll i = n - 1; i >= 0; i--)

#define all(x) x.begin(), x.end()
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define sz(x) (int)x.size()
#define len() length()

#define ff first
#define ss second

#define print2(a, b) cout << a << ' ' << b << endl
#define print3(a, b, c) cout << a << ' ' << b << ' ' << c << endl
#define print4(a, b, c, d) cout << a << ' ' << b << ' ' << c << '' << d << endl
#define printvec(a)       \
    for (auto c : a)      \
        cout << c << ' '; \
    cout << endl

typedef long long ll;
typedef long double ld;

typedef vector<int> vi;
typedef vector<ll> vll;
typedef vector<bool> vb;

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

void solve();

signed main()
{
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);

    int n = 1;

    //cin >> n;

    rep(i, n) solve();
}

void solve()
{
    int h, w, d, x, y;
    cin >> h >> w >> d;
    vector<string> a(h);
    rep(i, h) cin >> a[i];
    int L;
    cin >> L;
    string path;
    cin >> path;
    vector<vector<int>> leftfrom(h, vector<int>(w));
    vector<vector<int>> upfrom(h, vector<int>(w));
    vector<vector<int>> downfrom(h, vector<int>(w));
    vector<vector<int>> rightfrom(h, vector<int>(w));
    //cout << "HELLO\n";
    rep(i, h)
    {
        rep(j, w)
        {
            if (a[i][j] == 'S')
            {
                a[i][j] = '.';
                x = i;
                y = j;
                break;
            }
        }
    }
    rep(i, h)
    {
        leftfrom[i][0] = -1; //type of interest, index
        rightfrom[i][w - 1] = -1;
    }
    rep(i, w)
    {
        upfrom[0][i] = -1;
        downfrom[h - 1][i] = -1;
    }
    //cout << "HELLO\n";
    rep(i, h)
    {
        reep(j, 1, w)
        {
            if (a[i][j - 1] == '.')
            {
                leftfrom[i][j] = leftfrom[i][j - 1];
            }
            else
            {
                leftfrom[i][j] = j - 1;
            }
        }
    }
    rep(i, h)
    {
        per(j, w - 1)
        {
            if (a[i][j + 1] == '.')
            {
                rightfrom[i][j] = rightfrom[i][j + 1];
            }
            else
            {
                rightfrom[i][j] = j + 1;
            }
        }
    }
    reep(i, 1, h)
    {
        rep(j, w)
        {
            if (a[i - 1][j] == '.')
            {
                upfrom[i][j] = upfrom[i - 1][j];
            }
            else
            {
                upfrom[i][j] = i - 1;
            }
        }
    }
    per(i, h - 1)
    {
        rep(j, w)
        {
            if (a[i + 1][j] == '.')
            {
                downfrom[i][j] = downfrom[i + 1][j];
            }
            else
            {
                downfrom[i][j] = i + 1;
            }
        }
    }
    ll keys = 0;
    vector <int> ans(L);
    rep(i, L)
    {
        if (path[i] == 'U')
        {
            int xn = upfrom[x][y];
            if (xn == -1){
                ans[i] += x;
                x = 0;
            }
            else if (a[xn][y] == 'K'){
                keys += 1;
                ans[i] += abs(xn - x);
                x = xn;
                a[x][y] = '.';
                i--;
            } else if (a[xn][y] == 'L'){
                if (keys >= 1){
                    keys -= 1;
                    ans[i] += abs(xn - x);
                    x = xn;
                    a[x][y] = '.';
                    i--;
                } else {
                    ans[i] += abs(xn - x) - 1;
                    x = xn + 1;
                }
            } else if (a[xn][y] == '.'){
                ans[i] += abs(xn - x);
                x = xn;
                i--;
            } else if (a[xn][y] == '#'){
                ans[i] += abs(xn - x) - 1;
                x = xn + 1;
            } 
        }
        else if (path[i] == 'D')
        {
            int xn = downfrom[x][y];
            if (xn == -1){
                ans[i] += abs(h - 1 - x);
                x = h - 1;
            }
            else if (a[xn][y] == 'K'){
                keys += 1;
                ans[i] += abs(xn - x);
                x = xn;
                a[x][y] = '.';
                i--;
            } else if (a[xn][y] == 'L'){
                if (keys >= 1){
                    keys -= 1;
                    ans[i] += abs(xn - x);
                    x = xn;
                    a[x][y] = '.';
                    i--;
                } else {
                    ans[i] += abs(xn - x) - 1;
                    x = xn - 1;
                }
            } else if (a[xn][y] == '.'){
                ans[i] += abs(xn - x);
                x = xn;
                i--;
            } else if (a[xn][y] == '#'){
                ans[i] += abs(xn - x) - 1;
                x = xn - 1;
            } 
        }
        else if (path[i] == 'R'){
            int yn = rightfrom[x][y];
            if (yn == -1){
                ans[i] += abs(w - 1 - y);
                y = w - 1;
            }
            else if (a[x][yn] == 'K'){
                keys += 1;
                ans[i] += abs(yn - y);
                y = yn;
                a[x][y] = '.';
                i--;
            } else if (a[x][yn] == 'L'){
                if (keys >= 1){
                    keys -= 1;
                    ans[i] += abs(yn - y);
                    y = yn;
                    a[x][y] = '.';
                    i--;
                } else {
                    ans[i] += abs(yn - y) - 1;
                    y = yn - 1;
                }
            } else if (a[x][yn] == '.'){
                ans[i] += abs(yn - y);
                y = yn;
                i--;
            } else if (a[x][yn] == '#'){
                ans[i] += abs(yn - y) - 1;
                y = yn - 1;
            } 
        }
        else if (path[i] == 'L'){
            int yn = leftfrom[x][y];
            if (yn == -1){
                ans[i] += y;
                y = 0;
            }
            else if (a[x][yn] == 'K'){
                keys += 1;
                ans[i] += abs(yn - y);
                y = yn;
                a[x][y] = '.';
                i--;
            } else if (a[x][yn] == 'L'){
                if (keys >= 1){
                    keys -= 1;
                    ans[i] += abs(yn - y);
                    y = yn;
                    a[x][y] = '.';
                    i--;
                } else {
                    ans[i] += abs(yn - y) - 1;
                    y = yn + 1;
                }
            } else if (a[x][yn] == '.'){
                ans[i] += abs(yn - y);
                y = yn;
                i--;
            } else if (a[x][yn] == '#'){
                ans[i] += abs(yn - y) - 1;
                y = yn + 1;
            } 
        }
    }
    printvec(ans);
}