#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define sz(v) (int)(v).size()

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> indexed_set;

const ll INF = ll(2e9) + 100100, LINF = ll(1e18) + 100100;
const double EPS = 1e-9, PI = atan2(0.0, -1.0);
const int MODS[] = {signed(1e9) + 7, signed(1e9) + 9, 998244353};
const int PS[] = {117, 239, signed(1e5) + 3, 177013};
const int MAXN = signed(1e5) + 100, MAXLOG = 20;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

vector<pair<int, int>> ways = {
    {-1, -1},
    {-1, 0},
    {-1, 1},
    {0, -1},
    {0, 1},
    {1, -1},
    {1, 0},
    {1, 1}
};

int n;
vector<vector<int>> table;
vector<pair<int, int>> kings;

inline bool isOk(int i, int j) {
    return 0 <= i && i < n && 0 <= j && j < n;
}

inline bool check(int x, int y) {
    bool ok = true;

    for (auto &[i, j] : kings) {
        if (i != x) {
            if (j != y) {
                if (abs(x - i) != abs(y - j)) {
                    ok = false;
                    break;
                }
            }
        }
    }

    return ok;
}

inline void solve() {
    int m; cin >> n >> m;
    table.assign(n, vector<int>(n, 0));
    kings.clear();

    for (int i = 0; i < m; ++i) {
        int x, y; cin >> x >> y;
        table[--x][--y] = 1;

        for (auto &[dx, dy] : ways) {
            if (isOk(x + dx, y + dy)) table[x + dx][y + dy] = -1;
        }

        kings.push_back({x, y});
    }

    int ans = 0;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (table[i][j] == 0 && check(i, j)) ++ans;
        }
    }

    cout << ans << "\n";
}

signed main() {
    fastio;
#ifdef hikki
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int q; cin >> q;
    while (q--) solve();

    return 0;
}