#include <iostream>
#include <string>
#include <vector>

#define maxN 100000

struct state {
	bool closed = false;
	long long s, l = 0, r = 0, u = 0, d = 0;
};

long long h, w, d, x, y, l, k = 0;
std::string s;
std::vector<state> table[maxN];

int main() {
	std::cin >> h >> w >> d;
	for (long long i = 0; i < h; i++) {
		std::cin >> s;
		for (long long j = 0; j < w; j++) {
			if (s[j] == '.') {
				table[i].push_back({ false, 0 });
			}
			if (s[j] == '#') {
				table[i].push_back({ false, 1 });
			}
			if (s[j] == 'K') {
				table[i].push_back({ true, 2 });
			}
			if (s[j] == 'L') {
				table[i].push_back({ true, 3 });
			}
			if (s[j] == 'S') {
				x = i;
				y = j;
				table[i].push_back({ false, 0 });
			}
		}
	}
	for (long long i = 0; i < h; i++) {
		long long cur = 0;
		for (long long j = 0; j < w; j++) {
			table[i][j].l = cur;
			if (table[i][j].s == 1 || table[i][j].s == 2 || table[i][j].s == 3) {
				cur = j;
			}
		}
	}
	for (long long i = 0; i < h; i++) {
		long long cur = w - 1;
		for (long long j = w - 1; j >= 0; j--) {
			table[i][j].r = cur;
			if (table[i][j].s == 1 || table[i][j].s == 2 || table[i][j].s == 3) {
				cur = j;
			}
		}
	}
	for (long long j = 0; j < w; j++) {
		long long cur = 0;
		for (long long i = 0; i < h; i++) {
			table[i][j].u = cur;
			if (table[i][j].s == 1 || table[i][j].s == 2 || table[i][j].s == 3) {
				cur = i;
			}
		}
	}
	for (long long j = 0; j < w; j++) {
		long long cur = h - 1;
		for (long long i = h - 1; i >= 0; i--) {
			table[i][j].d = cur;
			if (table[i][j].s == 1 || table[i][j].s == 2|| table[i][j].s == 3) {
				cur = i;
			}
		}
	}
	std::cin >> l;
	std::cin >> s;
	for (long long i = 0; i < l; i++) {
		long long ans = 0;
		if (s[i] == 'U') {
			while (x != 0) {
				ans += x - table[x][y].u;
				x = table[x][y].u;
				if (table[x][y].s == 2 && table[x][y].closed) {
					k++;
					table[x][y].closed = false;
				}
				if (table[x][y].s == 3) {
					if (table[x][y].closed) {
						if (k == 0) {
							ans--;
							x++;
							break;
						}
						k--;
						table[x][y].closed = false;
					}
				}
				if (table[x][y].s == 1) {
					ans--;
					x++;
					break;
				}
			}
			std::cout << ans << "\n";
		}
		if (s[i] == 'R') {
			while (y != w - 1) {
				ans += table[x][y].r - y;
				y = table[x][y].r;
				if (table[x][y].s == 2 && table[x][y].closed) {
					k++;
					table[x][y].closed = false;
				}
				if (table[x][y].s == 3) {
					if (table[x][y].closed) {
						if (k == 0) {
							ans--;
							y--;
							break;
						}
						k--;
						table[x][y].closed = false;
					}
				}
				if (table[x][y].s == 1) {
					ans--;
					y--;
					break;
				}
			}
			std::cout << ans << "\n";
		}
		if (s[i] == 'D') {
			while (x != h - 1) {
				ans += table[x][y].d - x;
				x = table[x][y].d;
				if (table[x][y].s == 2 && table[x][y].closed) {
					k++;
					table[x][y].closed = false;
				}
				if (table[x][y].s == 3) {
					if (table[x][y].closed) {
						if (k == 0) {
							ans--;
							x--;
							break;
						}
						k--;
						table[x][y].closed = false;
					}
				}
				if (table[x][y].s == 1) {
					ans--;
					x--;
					break;
				}
			}
			std::cout << ans << "\n";
		}
		if (s[i] == 'L') {
			while (y != 0) {
				ans += y - table[x][y].l;
				y = table[x][y].l;
				if (table[x][y].s == 2 && table[x][y].closed) {
					k++;
					table[x][y].closed = false;
				}
				if (table[x][y].s == 3) {
					if (table[x][y].closed) {
						if (k == 0) {
							ans--;
							y++;
							break;
						}
						k--;
						table[x][y].closed = false;
					}
				}
				if (table[x][y].s == 1) {
					ans--;
					y++;
					break;
				}
			}
			std::cout << ans << "\n";
		}
	}
	return 0;
}