#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9 + 7;

void Solve() {
	
	int n, m, d;
	cin >> n >> m >> d;
	vector <string> v(n);
	for (auto& i : v) cin >> i;
	
	int x, y;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			if (v[i][j] == 'S')
				x = i, y = j, v[i][j] = '.';

	int l;
	string path;
	cin >> l >> path;

	vector <set <int>> horizontals(n);
	vector <set <int>> verticals(m);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (v[i][j] != '.') {
				horizontals[i].insert(j);
				verticals[j].insert(i);
			}
		}
	}

	int keys = 0;

	for (auto i : path) {
		if (i == 'L') {
			int init = y;
			while (1) {
				auto righter = horizontals[x].lower_bound(y);
				if (righter == horizontals[x].begin()) {
					y = 0;
					break;
				}
				auto lefter = prev(righter);
				y = *lefter + 1;
				if (v[x][*lefter] == '#') break;
				else if (v[x][*lefter] == 'K') {
					keys++;
					v[x][*lefter] = '.';
					verticals[*lefter].erase(x);
					horizontals[x].erase(lefter);
				}
				else if (v[x][*lefter] == 'L') {
					if (!keys) break;
					keys--;
					v[x][*lefter] = '.';
					verticals[*lefter].erase(x);
					horizontals[x].erase(lefter);

				}
			}
			cout << abs(y - init) << '\n';

		}
		else if (i == 'R') {
			int init = y;
			while (1) {
				auto righter = horizontals[x].lower_bound(y);
				if (righter == horizontals[x].end()) {
					y = m - 1;
					break;
				}
				y = *righter - 1;
				if (v[x][*righter] == '#') break;
				else if (v[x][*righter] == 'K') {
					keys++;
					v[x][*righter] = '.';
					verticals[*righter].erase(x);
					horizontals[x].erase(righter);

				}
				else	if (v[x][*righter] == 'L') {
					if (!keys) break;
					keys--;
					v[x][*righter] = '.';
					verticals[*righter].erase(x);
					horizontals[x].erase(righter);

				}
			}
			cout << abs(y - init) << '\n';

		}
		else if (i == 'U') {
			int init = x;
			while (1) {
				auto below = verticals[y].lower_bound(x);
				if (below == verticals[y].begin()) {
					x = 0;
					break;
				}
				auto upper = prev(below);
				x = *upper + 1;
				if (v[*upper][y] == '#') break;
				else if (v[*upper][y] == 'K') {
					keys++;
					v[*upper][y] = '.';
					horizontals[*upper].erase(y);
					verticals[y].erase(upper);
				}
				else if (v[*upper][y] == 'L') {
					if (!keys) break;
					keys--;
					v[*upper][y] = '.';
					horizontals[*upper].erase(y);
					verticals[y].erase(upper);

				}
			}
			cout << abs(x - init) << '\n';
		}
		else {
			int init = x;
			while (1) {
				auto below = verticals[y].lower_bound(x);
				if (below == verticals[y].end()) {
					x = n - 1;
					break;
				}
				x = *below - 1;
				if (v[*below][y] == '#') break;
				else if (v[*below][y] == 'K') {
					keys++;
					v[*below][y] = '.';
					horizontals[*below].erase(y);
					verticals[y].erase(below);

				}
				else if (v[*below][y] == 'L') {
					if (!keys) break;
					keys--;
					v[*below][y] = '.';
					horizontals[*below].erase(y);
					verticals[y].erase(below);

				}
			}
			cout << abs(x - init) << '\n';
		}
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	Solve();
}