#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9 + 7;

struct node {
	string name;
	node* lnk = nullptr;
	node(string name = "") : name(name) {};
};

node* ERROR;

void AddNew(map <string, node*> &m, string what) {
	if (!m.count(what)) {
		m[what] = new node(what);
	}
}

void MakePath(map <string, node*>& m, string from, string to) {
	AddNew(m, to);
	AddNew(m, from);
	if (m[from]->lnk == nullptr || m[from]->lnk == m[to]) 
		m[from]->lnk = m[to];
	else 
		m[from]->lnk = ERROR;
}

void PrintPath(map <string, node*>& m, string from) {
	AddNew(m, from);
	auto ptr = m[from];
	set <string> was;
	while (ptr->lnk != ptr && ptr->lnk != nullptr) {
		if (was.count(ptr->name)) {
			cout << "INFINITE LOOP\n";
			return;
		}
		was.insert(ptr->name);
		ptr = ptr->lnk;
	}
	cout << ptr->name << '\n';
}

void Solve() {
	int n, q;
	cin >> n;
	map <string, node*> m;

	AddNew(m, "TOO COMPLEX");
	ERROR = m["TOO COMPLEX"];


	for (int i = 0; i < n; i++) {
		string a, b, c;
		cin >> a >> b >> c;
		MakePath(m, a, c);
	}
	cin >> q;
	for (int i = 0; i < q; i++) {
		string type;
		cin >> type;
		if (type == "+") {
			string a, b, c;
			cin >> a >> b >> c;
			MakePath(m, a, c);
		}
		else {
			string c;
			cin >> c;
			PrintPath(m, c);
		}
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	Solve();
}