#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9 + 7;
const ll N = 1e7;

pair < ll, set <pair <ll, ll>>*> GetInit(int v, vector <vector <int>>& g, vector <ll>& a, vector <ll>& b) {
	ll res = a[v] * b[v];
	set <pair <ll, ll>>* kek = new set <pair <ll, ll>>();
	kek->insert({ 0, INF });
	kek->insert({ a[v], b[v] });
	return { res, kek };
}

// answer and values FIRST INC => SECOND DEC
pair <ll, set <pair <ll, ll>>*> Dfs(int v, int p, vector <vector <int>>& g, vector <ll>& a, vector <ll>& b, vector <ll> &ans) {
	vector < pair <ll, set <pair <ll, ll>>*>> answers = {
		GetInit(v, g, a, b)
	};
	int best = 0;
	for (auto i : g[v]) {
		if (i != p) {
			answers.push_back(Dfs(i, v, g, a, b, ans));
			if (best == -1 ||
				answers.back().second->size() > answers[best].second->size())
				best = answers.size() - 1;
		}
	}
	ll res = answers[best].first;
	set <pair <ll, ll>>* params = answers[best].second;
		//res = 0;
		//params = new set<pair <int, ll>>();
		//params->insert({ 0, INF });

	for (int i = 0; i < answers.size(); i++) {
		if (i == best) continue;
		for (auto &j : *answers[i].second) {
			if (params->count(j)) continue;
			params->insert(j);
			auto ptr = params->find(j);
			auto prv = prev(ptr);
			if (ptr != params->end()) {
				auto nxt = next(ptr);
				if (nxt->second >= j.second) {
					params->erase(ptr);
					continue;
				}
				else {
					res += (j.second - nxt->second) * (j.first - prv->first);
				}
			}
			while (prv->second < j.second) {
				auto pprv = prev(prv);
				res += (j.second - prv->second) * (prv->first - pprv->first);
				params->erase(prv);
				ptr = params->find(j);
				prv = prev(ptr);
			}
			
		}
	}

	ans[v] = res;
	return { res, params };
}

void Solve() {
	int n; cin >> n;
	vector <vector <int>> g(n);
	vector <ll> a(n);
	vector <ll> b(n);
	vector <ll> ans(n);
	for (int i = 0; i < n; i++) {
		int p;
		cin >> p >> a[i] >> b[i];
		if (p == 0) continue;
		g[p - 1].push_back(i);
	}
	Dfs(0, -1, g, a, b, ans);
	for (auto i : ans) cout << i << '\n';
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	Solve();
}