#include "iostream"
#include "vector"
#include "algorithm"
//#include "map"

using namespace std;

#define ll long long

//map<char, int> turn_code = { {'U', 0}, {'L', 1}, {'D', 2}, {'R', 3} };

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie();
	cout.tie();

	int h, w, d;
	cin >> h >> w >> d;
	h += 2, w += 2;
	vector<vector<char>> a(h, vector<char>(w));
	for (int i = 1; i < h - 1; i++)
		for (int j = 1; j < w - 1; j++)
			cin >> a[i][j];
	for (int i = 0; i < h; i++)
		a[i][0] = '#', a[i][w - 1] = '#';
	for (int j = 1; j < w - 1; j++)
		a[0][j] = '#', a[h - 1][j] = '#';

	/* DEBUG 
	cout << '\n';
	for (int i = 0; i < h; i++)
	{
		for (int j = 0; j < w; j++)
			cout << a[i][j];
		cout << '\n';
	}
	cout << '\n';
	*/

	//start
	int sx, sy;
	for (int i = 0; i < h; i++)
		for (int j = 0; j < w; j++)
			if (a[i][j] == 'S')
				sx = j, sy = i, a[i][j] = '.';

	//ULDR
	vector<vector<vector<int>>> b(h, vector<vector<int>>(w, vector<int>(4)));
	for (int j = 0; j < w; j++) //U
	{
		int y = 0;
		for (int i = 0; i < h; i++)
		{
			b[i][j][0] = y;
			if (a[i][j] != '.')
				y = i;
		}
	}
	for (int i = 0; i < h; i++) //L
	{
		int x = 0;
		for (int j = 0; j < w; j++)
		{
			b[i][j][1] = x;
			if (a[i][j] != '.')
				x = j;
		}
	}
	for (int j = 0; j < w; j++) //D
	{
		int y = h - 1;
		for (int i = h - 1; i >= 0; i--)
		{
			b[i][j][2] = y;
			if (a[i][j] != '.')
				y = i;
		}
	}
	for (int i = 0; i < h; i++) //R
	{
		int x = w - 1;
		for (int j = w - 1; j >= 0; j--)
		{
			b[i][j][3] = x;
			if (a[i][j] != '.')
				x = j;
		}
	}

	int q;
	cin >> q;
	int keys = 0;
	for (int tst = 0; tst < q; tst++)
	{
		char turn;
		cin >> turn;
		//int turn = turn_code[turn_c];

		int len = 0;

		while (1)
		{
			int fx, fy;
			if (turn == 'U')
				fx = sx, fy = b[sy][sx][0];
			else if (turn == 'L')
				fy = sy, fx = b[sy][sx][1];
			else if (turn == 'D')
				fx = sx, fy = b[sy][sx][2];
			else if (turn == 'R')
				fy = sy, fx = b[sy][sx][3];

			len += abs(fx - sx) + abs(fy - sy);

			if (a[fy][fx] == '#' || (a[fy][fx] == 'L' && keys == 0))
			{
				if (turn == 'U')
					sy = fy + 1;
				else if (turn == 'L')
					sx = fx + 1;
				else if (turn == 'D')
					sy = fy - 1;
				else if (turn == 'R')
					sx = fx - 1;

				cout << len - 1 << '\n';
				break;
			}
			else if (a[fy][fx] == 'L')
			{
				keys--;
				a[fy][fx] = '.';

				if (turn == 'U')
				{
					for (int i = fy + 1; b[i][sx][0] == fy; i++)
						b[i][sx][0] = b[fy][fx][0];
				}
				else if (turn == 'L')
				{
					for (int j = fx + 1; b[sy][j][1] == fx; j++)
						b[sy][j][1] = b[fy][fx][1];
				}
				else if (turn == 'D')
				{
					for (int i = fy - 1; b[i][sx][0] == fy; i--)
						b[i][sx][2] = b[fy][fx][2];
				}
				else if (turn == 'R')
				{
					for (int j = fx - 1; b[sy][j][1] == fx; j--)
						b[sy][j][3] = b[fy][fx][3];
				}
			}
			else if (a[fy][fx] == 'K')
			{
				keys++;
				a[fy][fx] = '.';

				if (turn == 'U')
				{
					for (int i = fy + 1; b[i][sx][0] == fy; i++)
						b[i][sx][0] = b[fy][fx][0];
				}
				else if (turn == 'L')
				{
					for (int j = fx + 1; b[sy][j][1] == fx; j++)
						b[sy][j][1] = b[fy][fx][1];
				}
				else if (turn == 'D')
				{
					for (int i = fy - 1; b[i][sx][0] == fy; i--)
						b[i][sx][2] = b[fy][fx][2];
				}
				else if (turn == 'R')
				{
					for (int j = fx - 1; b[sy][j][1] == fx; j--)
						b[sy][j][3] = b[fy][fx][3];
				}
			}

			sx = fx, sy = fy;
		}
	}

	return 0;
}