#include "iostream"
#include "vector"
#include "algorithm"
#include "set"
//#include "math"

#define ll long long
#define uint unsigned int

using namespace std;

const int V = 27 * 27 * 27 * 27;

int name(string& s)
{
	int res = 0;
	for (char i : s)
		res = res * 27 + i - 'A' + 1;
	return res;
}

string get_name(int x)
{
	string res;
	while (x > 0)
	{
		res.push_back((char)('A' + x % 27 - 1));
		x /= 27;
	}
	reverse(res.begin(), res.end());
	return res;
}

int get_last(int v, vector<int>& u)
{
	if (u[v] == v)
		return v;
	u[v] = get_last(u[v], u);
	return u[v];
}

void dfs(vector<vector<int>>& p, vector<int>& u, int v, int o, set<int>& ss)
{
	ss.insert(v);
	u[v] = o;
	for (int to : p[v])
		if (ss.find(to) == ss.end())
			dfs(p, u, to, o, ss);
}

void add_edge(int v, int to, vector<int>& g, vector<vector<int>>& p, vector<int>& u, vector<bool>& c)
{
	if (g[v] == to)
		return;

	if (g[v] == 0 && v == to)
	{
		g[v] = to;
	}

	else if (g[v] == 0)
	{
		g[v] = to;
		
		if (get_last(to, u) == v)
		{
			c[v] = 1;
		}
		else
		{
			u[v] = u[to];
			p[to].push_back(v);
		}
	}

	else
	{
		g[v] = -1;
		set<int> ss;
		dfs(p, u, v, v, ss);
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie();
	cout.tie();

	vector<int> g(V, 0);
	vector<vector<int>> p(V);
	vector<int> u(V);
	for (int i = 0; i < V; i++) u[i] = i;
	vector<bool> c(V, 0);

	int n;
	cin >> n;
	
	string s_ai, s_is, s_bi;
	for (int i = 0; i < n; i++)
	{
		cin >> s_ai >> s_is >> s_bi;
		int ai = name(s_ai), bi = name(s_bi);
		add_edge(ai, bi, g, p, u, c);
	}

	int q;
	cin >> q;
	for (int qu = 0; qu < q; qu++)
	{
		char tp;
		cin >> tp;

		if (tp == '+')
		{
			cin >> s_ai >> s_is >> s_bi;
			int ai = name(s_ai), bi = name(s_bi);
			add_edge(ai, bi, g, p, u, c);
		}
		else
		{
			cin >> s_ai;
			int ai = name(s_ai);
			int v = get_last(ai, u);

			if (g[v] == -1)
				cout << "TOO COMPLEX\n";
			else if (c[v])
				cout << "INFINITE LOOP\n";
			else
				cout << get_name(v) << '\n';
		}
	}

	return 0;
}