﻿#include <algorithm>
#include <iostream>
#include <vector>
#include <map>
#include <set>

using namespace std;

int n, q, idx = 0;
map < string, int > mp;
vector < string > vs;
vector < bool > used;
vector < vector < int > > g;

void add()
{
	string s1, s2;
	cin >> s1 >> s2 >> s2;
	if (mp.find(s1) == mp.end())
	{
		mp[s1] = idx++;
		vs.push_back(s1);
		g.push_back(vector < int >(3, -1));
	}
	if (mp.find(s2) == mp.end())
	{
		mp[s2] = idx++;
		vs.push_back(s2);
		g.push_back(vector < int >(3, -1));
	}
	int u = mp[s1], v = mp[s2];
	if (g[u][0] == v || g[u][1] == v || g[u][2] == v)
		return;
	else
		if (g[u][0] == -1)
			g[u][0] = v;
		else if (g[u][1] == -1)
			g[u][1] = v;
		else if (g[u][2] == -1)
			g[u][2] = v;
}

int dfs(int u)
{
	used[u] = true;
	if (g[u][0] != -1 && g[u][1] != -1)
		return -1;
	if (g[u][0] != -1)
	{
		if (g[u][0] == u)
			return u;
		if (used[g[u][0]])
			return -2;
		return dfs(g[u][0]);
	}
	return u;
}

void check()
{
	string s;
	cin >> s;
	if (mp.find(s) == mp.end())
	{
		cout << s << endl;
		return;
	}
	used.assign(idx + 1, false);
	int res = dfs(mp[s]);
	if (res == -1)
		cout << "TOO COMPLEX\n";
	else if (res == -2)
		cout << "INFINITE LOOP\n";
	else
		cout << vs[res] << endl;
}

int main()
{
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		string s1, s2;
		cin >> s1 >> s2 >> s2;
		if (mp.find(s1) == mp.end())
		{
			mp[s1] = idx++;
			vs.push_back(s1);
			g.push_back(vector < int >(3, -1));
		}
		if (mp.find(s2) == mp.end())
		{
			mp[s2] = idx++;
			vs.push_back(s2);
			g.push_back(vector < int >(3, -1));
		}
		int u = mp[s1], v = mp[s2];
		if (g[u][0] == v || g[u][1] == v || g[u][2] == v)
			continue;
		else
			if (g[u][0] == -1)
				g[u][0] = v;
			else if (g[u][1] == -1)
				g[u][1] = v;
			else if (g[u][2] == -1)
				g[u][2] = v;
	}
	cin >> q;
	for (int i = 0; i < q; i++)
	{
		char type;
		cin >> type;
		if (type == '+')
			add();
		else if (type == '?')
			check();
	}

	return 0;
}